import objects.Note;
import shaders.RGBPalette.RGBShaderReference;

using StringTools;

var defaultNoteTypes = ['', 'Alt Animation', 'No Animation', 'GF Sing', 'Hey!', 'Hurt Note'];

function setNoteTexture(id:Int, ?noteType:String) {

    var oldNote = game.notes.members[id];

    game.notes.members[id].kill();
    game.notes.remove(game.notes.members[id]);

    var newNote = new Note(oldNote.strumTime, oldNote.noteData, oldNote.prevNote, oldNote.isSustainNote, oldNote.inEditor, oldNote.createdFrom);
    newNote.mustPress = oldNote.mustPress;
    newNote.sustainLength = oldNote.sustainLength;
    newNote.parent = oldNote.parent;
    newNote.ignoreNote = oldNote.ignoreNote;
    newNote.nextNote = oldNote.nextNote;
    newNote.gfNote = oldNote.gfNote;
    newNote.canBeHit = oldNote.canBeHit;
    newNote.scale.y = oldNote.scale.y;
    newNote.offsetX = oldNote.offsetX;
    newNote.offsetY = oldNote.offsetY;

    if (newNote.isSustainNote) {
        
        newNote.correctionOffset = newNote.parent.height / 2;

        if (newNote.prevNote != null && newNote.nextNote != null && oldNote.nextNote.isSustainNote) {
            newNote.animation.play(Note.colArray[newNote.noteData % Note.colArray.length] + 'hold');
        }
    }

    if (noteType != null) {
        
        if (defaultNoteTypes.contains(noteType)) newNote.reloadNote('', '');
        else {
            newNote.rgbShader.enabled = false;
            newNote.reloadNote('notes/' + noteType.toUpperCase().replace(' ', '') + '_assets');
        }

        newNote.set_noteType(noteType);
    }

    game.notes.insert(id, newNote);
    newNote.spawned = true;
    if (newNote.parent != null) newNote.parent.wasGoodHit = true; //Fix bc guitarHeroStrums wasn't working and wouldn't change this setting on the parent note

    return;
}